#include "dns.h"

unsigned dns_dntol(const unsigned char *srcdn, unsigned char *dstdn,
	unsigned dstsiz) {
  unsigned c;
  const unsigned char *s = srcdn;
  unsigned char *e = dstdn + dstsiz;
  if (!dstsiz) return 0;
  while((c = (*dstdn++ = *s++)) != 0) {
    if (c > DNS_MAXLABEL) return 0;
    if (dstdn + c >= e) return 0;
    do {
      *dstdn++ = dns_dnlc(*s);
      ++s;
    } while(--c);
  }
  return (unsigned)(s - srcdn);
}
